<CsoundSynthesizer>
<CsOptions>
-o dac -d --messagelevel=2
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	1
nchnls	=	2
0dbfs	=	1

garev init 0 ; global reverb signal

instr Setup
	iroomfn init p4
	a1 vco2 1, 440, 0
	; Read room parameters
	irfade table 0, iroomfn, 0
	irorder table 1, iroomfn, 0
	irx table 2, iroomfn, 0
	iry table 3, iroomfn, 0
	irz table 4, iroomfn, 0
	irwallhi table 5, iroomfn, 0
	irwalllo table 6, iroomfn, 0
	irwallg1 table 7, iroomfn, 0
	irwallg2 table 8, iroomfn, 0
	irwallg3 table 9, iroomfn, 0
	irfloorhi table 10, iroomfn, 0
	irfloorlo table 11, iroomfn, 0
	irfloorg1 table 12, iroomfn, 0
	irfloorg2 table 13, iroomfn, 0
	irfloorg3 table 14, iroomfn, 0
	irceilhi table 15, iroomfn, 0
	irceillo table 16, iroomfn, 0
	irceilg1 table 17, iroomfn, 0
	irceilg2 table 18, iroomfn, 0
	irceilg3 table 19, iroomfn, 0

	; position the sound and loop it
	Sleft sprintf "hrtf-%d-left.dat", sr
	Sright sprintf "hrtf-%d-right.dat", sr
	al, ar, irtl, irth, imfp hrtfearly a1, irx/2, .1, irz/2, irx/2, iry/2, irz/2, Sleft, Sright, 0, irfade, sr, irorder, 1, 0, irx, iry, irz, irwallhi, irwalllo, irwallg1, irwallg2, irwallg3, irfloorhi, irfloorlo, irfloorg1, irfloorg2, irfloorg3, irceilhi, irceillo, irceilg1, irceilg2, irceilg3

	; Write the data for hrtfreverb to room ftable
	tabw_i irtl, 20, iroomfn
	tabw_i irth, 21, iroomfn
	tabw_i imfp, 22, iroomfn

	; Write new room function including rtlow, rthigh and mfp
	iIndex init 0
	while iIndex < ftlen(iroomfn) do
		fprints p5, "%f\n", tab_i(iIndex, iroomfn)
		iIndex += 1
	od
	outs al, ar
endin

instr Test_room
	iroomfn init p4
	; Read room parameters
	irfade table 0, iroomfn, 0
	irorder table 1, iroomfn, 0
	irx table 2, iroomfn, 0
	iry table 3, iroomfn, 0
	irz table 4, iroomfn, 0
	irwallhi table 5, iroomfn, 0
	irwalllo table 6, iroomfn, 0
	irwallg1 table 7, iroomfn, 0
	irwallg2 table 8, iroomfn, 0
	irwallg3 table 9, iroomfn, 0
	irfloorhi table 10, iroomfn, 0
	irfloorlo table 11, iroomfn, 0
	irfloorg1 table 12, iroomfn, 0
	irfloorg2 table 13, iroomfn, 0
	irfloorg3 table 14, iroomfn, 0
	irceilhi table 15, iroomfn, 0
	irceillo table 16, iroomfn, 0
	irceilg1 table 17, iroomfn, 0
	irceilg2 table 18, iroomfn, 0
	irceilg3 table 19, iroomfn, 0
	irtl table 20, iroomfn, 0
	irth table 21, iroomfn, 0
	imfp table 22, iroomfn, 0
	Sleft sprintf "hrtf-%d-left.dat", sr
	Sright sprintf "hrtf-%d-right.dat", sr

	; Set up listener coordinates
	ilx init irx / 2
	ily init iry / 2
	if irz < 1.5 then
		ilz init irz / 2
	else
		ilz init 1.25
	endif

	; Produce audio impulse
	if p3 < 3 then
		xtratim (3 - p3)
	endif

	kenv expon 1, .2, .0001
	aoscil vco2 kenv, 220, 0

	; Pass audio through HRTF
	al, ar, irtl1, irth1, imfp1 hrtfearly aoscil, p5, p6, p7, ilx, ily, ilz, Sleft, Sright, 0, irfade, sr, irorder, 1, 0, irx, iry, irz, irwallhi, irwalllo, irwallg1, irwallg2, irwallg3, irfloorhi, irfloorlo, irfloorg1, irfloorg2, irfloorg3, irceilhi, irceillo, irceilg1, irceilg2, irceilg3
	garev = garev + aoscil
	outs al, ar
endin

instr Global_rev
	iroomfn init p4
	iorder table 1, iroomfn, 0
	irtl table 20, iroomfn, 0
	irth table 21, iroomfn, 0
	imfp table 22, iroomfn, 0
	Sleft sprintf "hrtf-%d-left.dat", sr
	Sright sprintf "hrtf-%d-right.dat", sr
	al, ar, idel hrtfreverb garev, irtl, irth, Sleft, Sright, sr, imfp, iorder
	aleft delay al*.1, idel
	aright delay ar*.1, idel
	outs aleft, aright
	garev = 0
endin

instr Play_test
	; Read necessary room parameters
	iroomfn init p4
	irx table 2, iroomfn, 0
	iry table 3, iroomfn, 0
	irz table 4, iroomfn, 0
	irtl table 20, iroomfn, 0
	irth table 21, iroomfn, 0

	; Set up global reverb instrument
	if irth <= irtl then
		event_i "i", "Global_rev", 0, (8 + irtl), iroomfn
	else
		event_i "i", "Global_rev", 0, (8 + irth), iroomfn
	endif

	; Set up x, y and z coordinates for test tones
	if irz < 1.5 then
		isz init irz / 2
	else
		isz init 1.25
	endif

	kkx[] fillarray .1, (irx / 2), (irx - .1), (irx - .1), (irx - .1), (irx / 2), .1, .1
	kky[] fillarray .1, .1, .1, (iry / 2), (iry - .1), (iry - .1), (iry - .1), (iry / 2)

	; Set up playback
	ktrig metro 1
	kndx init 0

	if ktrig == 1 then
		if kndx < 8 then
			event "i", "Test_room", 0, 3, iroomfn, kkx[kndx], kky[kndx], isz
			kndx += 1
		endif
	endif
endin

</CsInstruments>
; ==============================================
<CsScore>
f1 0 23 -23 "room_in.ftable"

i"Setup" 0 .1 1 "room_out.ftable"
i"Play_test" .2 11 1
e
</CsScore>
</CsoundSynthesizer>
