/*
m_ball - a kind of table tennis ball being hit

DESCRIPTION
A simplistic sound-alike of a table tennis ball being hit.

SYNTAX
aOut m_ball ksize, ktrig

INITIALIZATION

PERFORMANCE
ksize - inverse size of the ball, between 0 and 1
ktrig - Trigger to hit the ball

CREDITS
Author: Jeanette C.
*/

opcode m_ball, a, kk
	ksize, ktrig xin

	; Set up parameter
	; Parameters for the nlfilt (nonlinear filter)
	kL = 8 + (12 * ksize)
	kamp, kfin m_segk .7, .1, 0, 2, ktrig

	aNoise fractalnoise kamp, 1
	aFilter nlfilt aNoise, .1, .1, .6, .6, kL
	aHP butterhp (aFilter * kamp), (600 + ksize * 300)
	aAlpass alpass aHP, .002, .01
	aLP butterlp (aHP *.8 + aAlpass * .2), (8000 - ksize * 4000)
	aOut = aLP

	; Output audio
	xout aOut
endop
