/*
m_bar - a struck metal bar

DESCRIPTION

SYNTAX
aout m_bar iforce, ipitch, idamp, kscan

INITIALIZATION
iforce - Force the bar is struck with, between 0 and 1
ipitch - Pitch of the bar, best between 16 and 128)
idamp - high frequency damping, between 0 and 1 (0 is undampened)

PERFORMANCE
kscan - Speed travelling along the bar, between 0 and ...

CREDITS
Author: Jeanette C.
*/

opcode m_bar, a, iiik
	iforce, ipitch, idamp, kscan xin

	; Setup variables
	kbcL init 1
	kbcR init 3
	iK init ipitch
	ib init idamp
	iT30 init p3*.75
	ipos init .7
	ivel init 100 + (iforce * 400)
	iwid init .05

	aBar barmodel kbcL, kbcR, iK, ib, kscan, iT30, ipos, ivel, iwid
	aHP butterhp aBar*(4 * ipitch), 29.135*ipitch
	aOut = aHP

	; Output the audio
	xout aOut
endop
