/*
m_flute - simple flute with only pitch control

DESCRIPTION
This opcode uses wgflute, preconfigured so it only needs a pitch control.

SYNTAX
aout m_flute kpitch

INITIALIZATION

PERFORMANCE
kpitch - Pitch in Hz

CREDITS
Author: Jeanette C.
*/

opcode m_flute, a, k
	kpitch xin

	kamp linseg 0, .05, .6, p3-.1, .6, .05, 0
	kjet init .25
	iatt init .1
	idetk init .15
	kngain init .02
	kvibf init 0
	kvamp init 0
	aflute wgflute kamp, kpitch, kjet, iatt, idetk, kngain, kvibf, kvamp
	aout butterlp aflute, 3000

	; Output the audio
	xout aout
endop
