/*
m_pipe - The big pipe

DESCRIPTION
The big short pipe sound.

SYNTAX
aout m_pipe ksize

INITIALIZATION

PERFORMANCE
ksize - Inverse size of the instrument (0 to 1)

CREDITS
Author: Jeanette C.
*/

opcode m_pipe, a, k
	ksize xin

	; Setup parameters
	kamp linseg 0, .05, .9, p3-.05, 0
	ifreq = 40 + (80 * i(ksize))
	kstiff init -.3
	iatt init .1
	idetk init .2
	kngain init .7
	kvibf init 0
	kvamp init 0
	klpf linseg 10000, .4, ifreq*8, p3-.4, ifreq*8
	kpick line .9, p3, .75

	aClarinet wgclar kamp, ifreq, kstiff, iatt, idetk, kngain, kvibf, kvamp
	aPluck wgpluck2 .75, kamp, ifreq, kpick, .8
	aReso wguide1 (aClarinet+aPluck)*.5, ifreq*.5, klpf, .75
	aLP butterlp aReso*kamp, klpf*.25
	aOut = aLP

	; Output the audio
	xout aOut
endop
