/*
m_wind - Wind in the wires

DESCRIPTION
Very simplistic wind strumming a wire.

SYNTAX
aout m_wind kstrength, ksize

INITIALIZATION

PERFORMANCE
kstrnegth - Strnegth of the wind, between 0 and 1
ksize - Size of the wire, between 0 and 1

CREDITS
Author: Jeanette C.
*/
opcode m_wind, a, kk
	kstrength, ksize xin

	kamp expcurve kstrength, 2
	kVibDepth = expcurve(kstrength, 2) * 200
	kVibFreq = 1 + expcurve(kstrength,1.1) * 19
	kVibrato randh kVibDepth, kVibFreq, 2
	kVibrato portk kVibrato, .5/kVibFreq
	kcf = (900 + ksize * 800) * (kstrength + 1) + kVibrato
	kbw = 6 + (1 - kstrength) * 10 + (kVibrato * .025)
	aNoise fractalnoise kamp, 0
	aBP butterbp aNoise, kcf, kbw
	
	; Output audio
	xout aBP
endop
